"use strict";

var __createBinding = this && this.__createBinding || (Object.create ? function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  Object.defineProperty(o, k2, {
    enumerable: true,
    get: function get() {
      return m[k];
    }
  });
} : function (o, m, k, k2) {
  if (k2 === undefined) k2 = k;
  o[k2] = m[k];
});

var __setModuleDefault = this && this.__setModuleDefault || (Object.create ? function (o, v) {
  Object.defineProperty(o, "default", {
    enumerable: true,
    value: v
  });
} : function (o, v) {
  o["default"] = v;
});

var __importStar = this && this.__importStar || function (mod) {
  if (mod && mod.__esModule) return mod;
  var result = {};
  if (mod != null) for (var k in mod) {
    if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
  }

  __setModuleDefault(result, mod);

  return result;
};

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CheckListItem = void 0;

var react_1 = __importStar(require("react"));

var list_1 = __importDefault(require("../list"));

var native_props_1 = require("../../utils/native-props");

var context_1 = require("./context");

var dev_log_1 = require("../../utils/dev-log");

var icons_1 = require("@ant-design/icons");

exports.CheckListItem = function (props) {
  var context = react_1.useContext(context_1.CheckListContext);

  if (context === null) {
    dev_log_1.devWarning('CheckList.Item', 'CheckList.Item can only be used inside CheckList.');
    return null;
  }

  var active = context.value.includes(props.value);
  var extra = react_1["default"].createElement("div", {
    className: 'adm-check-list-item-extra'
  }, active ? react_1["default"].createElement(icons_1.CheckOutlined, null) : null);
  return native_props_1.withNativeProps(props, react_1["default"].createElement(list_1["default"].Item, {
    title: props.title,
    description: props.description,
    prefix: props.prefix,
    onClick: function onClick() {
      var _a;

      if (active) {
        context.uncheck(props.value);
      } else {
        context.check(props.value);
      }

      (_a = props.onClick) === null || _a === void 0 ? void 0 : _a.call(props);
    },
    arrow: false,
    clickable: true,
    extra: extra
  }, props.children));
};