"use strict";

var __importDefault = this && this.__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CheckList = void 0;

var react_1 = __importDefault(require("react"));

var native_props_1 = require("../../utils/native-props");

var list_1 = __importDefault(require("../list"));

var with_default_props_1 = require("../../utils/with-default-props");

var context_1 = require("./context");

var use_controllable_value_1 = require("../../utils/use-controllable-value");

var defaultProps = {
  multiple: false,
  defaultValue: []
};

exports.CheckList = function (p) {
  var props = with_default_props_1.mergeProps(defaultProps, p);

  var _use_controllable_val = use_controllable_value_1.useNewControllableValue(props),
      value = _use_controllable_val[0],
      setValue = _use_controllable_val[1];

  function check(val) {
    if (props.multiple) {
      setValue([].concat(value, [val]));
    } else {
      setValue([val]);
    }
  }

  function uncheck(val) {
    setValue(value.filter(function (item) {
      return item !== val;
    }));
  }

  return native_props_1.withNativeProps(props, react_1["default"].createElement(context_1.CheckListContext.Provider, {
    value: {
      value: value,
      check: check,
      uncheck: uncheck
    }
  }, react_1["default"].createElement(list_1["default"], {
    mode: props.mode
  }, props.children)));
};